"use strict";Object.defineProperty(exports, "__esModule", {value: true});// src/hoist-static/transfrom.ts
var _common = require('@vue-macros/common');
var transformHoistStatic = (ctx) => {
  function moveToScript(decl, prefix = "") {
    const text = s.slice(startOffset + decl.start, startOffset + decl.end);
    scriptCode.prepend += `
${prefix}${text}`;
    removeScriptSetup(decl.start, decl.end);
  }
  function removeScriptSetup(start, end) {
    s.remove(startOffset + start, startOffset + end);
    const { content } = scriptSetup;
    scriptSetup.content = `${content.slice(0, start)}${" ".repeat(
      end - start
    )}${content.slice(end)}`;
  }
  const { sfc, s, scriptCode } = ctx;
  const { scriptSetup, lang } = sfc;
  if (!scriptSetup)
    return;
  const startOffset = scriptSetup.loc.start.offset;
  const program = _common.babelParse.call(void 0, scriptSetup.loc.source, lang);
  for (const stmt of program.body) {
    if (stmt.type === "VariableDeclaration" && stmt.kind === "const") {
      const decls = stmt.declarations;
      let count = 0;
      for (const [i, decl] of decls.entries()) {
        if (!decl.init || !_common.isStaticExpression.call(void 0, decl.init))
          continue;
        count++;
        moveToScript(decl, "const ");
        if (decls.length > 1) {
          const isLast = i === decls.length - 1;
          const start = isLast ? decls[i - 1].end : decl.end;
          const end = isLast ? decl.start : decls[i + 1].start;
          s.remove(startOffset + start, startOffset + end);
        }
      }
      if (count === decls.length) {
        removeScriptSetup(stmt.start, stmt.end);
      }
    } else if (stmt.type === "TSEnumDeclaration") {
      const isAllConstant = stmt.members.every(
        (member) => !member.initializer || _common.isStaticExpression.call(void 0, member.initializer)
      );
      if (!isAllConstant)
        continue;
      moveToScript(stmt);
    }
  }
};



exports.transformHoistStatic = transformHoistStatic;
